UE3-Angabe/assignment/src/main/java/at/ac/tuwien/big/we16/ue3/model/Product.java
package at.ac.tuwien.big.we16.ue3.model;

import at.ac.tuwien.big.we16.ue3.exception.InvalidBidException;
import org.hibernate.annotations.Fetch;
import org.hibernate.annotations.FetchMode;

import javax.persistence.*;
import java.io.Serializable;
import java.util.Date;
import java.util.List;
import java.util.Set;
import java.util.stream.Collectors;

@Entity
@Table(name = "Product")
public class Product implements Serializable{
	
	@Id
    @GeneratedValue(strategy=GenerationType.IDENTITY)
    private String id;
    private String name;
    private String image;
    private String imageAlt;
    private Date auctionEnd;
    
    @Enumerated
    private ProductType type;
    private int year;
    private String producer;
    private boolean expired;
    
    @OneToMany(mappedBy="product", fetch=FetchType.EAGER )
    @Fetch(FetchMode.SELECT)
    private List<RelatedProduct> relatedProducts;
    
    @OneToMany(mappedBy="product", fetch=FetchType.EAGER)
    @Fetch(FetchMode.SELECT)
    private List<Bid> bids;

    public Bid getHighestBid() {
        Bid highest = null;
        int highestAmount = 0;
        for (Bid bid : this.bids) {
            if (bid.getAmount() > highestAmount) {
                highest = bid;
            }
        }
        return highest;
    }

    public boolean hasAuctionEnded() {
        return this.getAuctionEnd().before(new Date());
    }

    public void addBid(Bid bid) throws InvalidBidException {
        this.bids.add(bid);
    }

    public boolean hasExpired() {
        return expired;
    }

    public void setExpired() {
        this.expired = true;
    }

    public Set<User> getUsers() {
        Set<User> users = this.bids.stream().map(Bid::getUser).collect(Collectors.toSet());
        return users;
    }

    public boolean hasBids() {
        return this.bids.size() > 0;
    }

    public boolean isValidBidAmount(int amount) {
        return !this.hasBids() || this.getHighestBid().getAmount() < amount;
    }

    public boolean hasBidByUser(User user) {
        for (Bid bid : this.bids) {
            if (bid.getUser().equals(user)) {
                return true;
            }
        }
        return false;
    }

    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    public String getName() {
        return name;
    }

    public String getImage() {
        return image;
    }

    public String getImageAlt() {
        return imageAlt;
    }

    public Date getAuctionEnd() {
        return auctionEnd;
    }

    public ProductType getType() {
        return type;
    }

    public void setType(ProductType type) {
        this.type = type;
    }

    public List<RelatedProduct> getRelatedProducts() {
        return relatedProducts;
    }
    
    public void setYear(int year) {
    	this.year = year;
    }
    
    public void setName(String name) {
    	this.name = name;
    }

    public void setImage(String image) {
        this.image = image;
    }

    public void setImageAlt(String imageAlt) {
        this.imageAlt = imageAlt;
    }

    public void setAuctionEnd(Date auctionEnd) {
        this.auctionEnd = auctionEnd;
    }

    public void setProducer(String producer) {
        this.producer = producer;
    }

    public void setExpired(boolean expired) {
        this.expired = expired;
    }

    public void setRelatedProducts(List<RelatedProduct> relatedProducts) {
        this.relatedProducts = relatedProducts;
    }

    public void setBids(List<Bid> bids) {
        this.bids = bids;
    }

    public int getYear() {
        return year;
    }

    public String getProducer() {
        return producer;
    }

    public boolean isExpired() {
        return expired;
    }

    public List<Bid> getBids() {
        return bids;
    }
}

UE3-Angabe/assignment/src/main/java/at/ac/tuwien/big/we16/ue3/model/User.java
package at.ac.tuwien.big.we16.ue3.model;

import javax.persistence.*;
import java.io.Serializable;
import java.util.Date;

@Entity
@Table(name = "User")
public class User implements Serializable{


	@Id
    @GeneratedValue(strategy=GenerationType.IDENTITY)
    private String id;
    private String salutation;
    private String firstname;
    private String lastname;
    private String email;
    private String password;
    private Date date;
    private int balance;
    private int runningAuctionsCount;
    private int wonAuctionsCount;
    private int lostAuctionsCount;

    
    
    public String getId() {
		return id;
	}

	public void setId(String id) {
		this.id = id;
	}

	public int getBalance() {
		return balance;
	}

	public void setBalance(int balance) {
		this.balance = balance;
	}

	public void setSalutation(String salutation) {
		this.salutation = salutation;
	}

	public void setFirstname(String firstname) {
		this.firstname = firstname;
	}

	public void setLastname(String lastname) {
		this.lastname = lastname;
	}

	public void setEmail(String email) {
		this.email = email;
	}

	public void setRunningAuctionsCount(int runningAuctionsCount) {
		this.runningAuctionsCount = runningAuctionsCount;
	}

	public void setWonAuctionsCount(int wonAuctionsCount) {
		this.wonAuctionsCount = wonAuctionsCount;
	}

	public void setLostAuctionsCount(int lostAuctionsCount) {
		this.lostAuctionsCount = lostAuctionsCount;
	}

	public String getFullName() {
        return this.firstname + " " + this.lastname;
    }

    public void setPassword(String password) {
        this.password = password;
    }

    public String getPassword() {
        return password;
    }

    public float getConvertedBalance() {
        float convertedBalance = (float)this.balance;
        return convertedBalance / 100;
    }

    public void decreaseBalance(int amount) {
        this.balance -= amount;
    }

    public void increaseBalance(int amount) {
        this.balance += amount;
    }

    public int getRunningAuctionsCount() {
        return this.runningAuctionsCount;
    }

    public void incrementRunningAuctions() {
        this.runningAuctionsCount++;
    }

    public void decrementRunningAuctions() {
        this.runningAuctionsCount--;
    }

    public int getWonAuctionsCount() {
        return this.wonAuctionsCount;
    }

    public int getLostAuctionsCount() {
        return this.lostAuctionsCount;
    }

    public void incrementLostAuctionsCount() {
        this.lostAuctionsCount++;
    }

    public void incrementWonAuctionsCount() {
        this.wonAuctionsCount++;
    }

    public boolean hasSufficientBalance(int amount) {
        return this.balance >= amount;
    }

    public String getEmail() {
        return email;
    }

    public String getSalutation() {
        return salutation;
    }

    public Date getDate() {
        return date;
    }

    public void setDate(Date date) {
        this.date = date;
    }

    public String getFirstname() {
        return firstname;
    }

    public String getLastname() {
        return lastname;
    }


}

UE3-Angabe/assignment/src/main/webapp/views/details.jsp
<%@ page contentType="text/html;charset=UTF-8" language="java" %>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<fmt:setBundle basename="messages" />
<jsp:useBean id="product" scope="request" type="at.ac.tuwien.big.we16.ue3.model.Product"/>
<c:set var="localeCode" value="${pageContext.response.locale}" />
<jsp:include page='partials/header.jsp'>
    <jsp:param name="title" value="${product.name}" />
    <jsp:param name="showLogout" value="true" />
</jsp:include>
<jsp:include page='partials/sidebar.jsp'/>


<main aria-labelledby="productheadline" class="details-container">
        <div class="details-image-container">
            <img class="details-image" src="/images/${product.image}" alt="${product.imageAlt}">
        </div>
        <div data-product-id="${product.id}" class="details-data">
            <h2 class="main-headline" id="productheadline">${product.name}</h2>
            <div class="auction-expired-text" <c:if test="${!product.hasAuctionEnded()}">style="display:none"</c:if>>
                <p>
                    Diese Auktion ist bereits abgelaufen.
                    Das Produkt wurde um <span class="highest-bid">
                                <c:if test="${product.hasBids()}">
                                    <fmt:formatNumber value="${product.highestBid.convertedAmount}" maxFractionDigits="2" minFractionDigits="2"/> €
                                </c:if>
                            </span> an <span class="highest-bidder">
                                <c:if test="${product.hasBids()}">
                                    ${product.highestBid.user.fullName}
                                </c:if>
                            </span> verkauft.
                </p>
            </div>
            <c:if test="${!product.hasAuctionEnded()}">
                <p class="detail-time">Restzeit: <span data-end-time="<fmt:formatDate value="${product.auctionEnd}" pattern="yyyy,MM,dd,HH,mm,ss,SSS"/>" class="detail-rest-time js-time-left"></span></p>
                <form class="bid-form" method="post" action="/product/${product.id}/bid">
                    <label class="bid-form-field" id="highest-price">
                        <c:choose>
                            <c:when test="${product.hasBids()}">
                                <span class="highest-bid"><fmt:formatNumber value="${product.highestBid.convertedAmount}" maxFractionDigits="2" minFractionDigits="2"/> €</span>
                                <span class="highest-bidder">${product.highestBid.user.fullName}</span>
                            </c:when>
                            <c:otherwise>
                                <span class="highest-bid">Noch keine Gebote</span>
                                <span class="highest-bidder"></span>
                            </c:otherwise>
                        </c:choose>
                    </label>
                    <label class="accessibility" for="new-price"></label>
                    <input type="number" step="0.01" min="0" id="new-price" class="bid-form-field form-input" name="new-price" required>
                    <p class="bid-error">Es gibt bereits ein h\u00F6heres Gebot oder der Kontostand ist zu niedrig.</p>
                    <input type="submit" id="submit-price" class="bid-form-field button" name="submit-price" value="Bieten">
                </form>
            </c:if>
            <h2 class="sub-main-headline" id="relatedproductsheadline">&Auml;hnliche Produkte</h2>
            <ul class="related-products-list">
                <c:forEach items="${product.relatedProducts}" var="relatedProduct">
                    <li>${relatedProduct.name}</li>
                </c:forEach>
            </ul>
        </div>
</main>
<jsp:include page='partials/footer.jsp'/>

UE3-Angabe/assignment/src/main/webapp/views/login.jsp
<%@ page contentType="text/html;charset=UTF-8" language="java" %>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<fmt:setBundle basename="messages" />
<jsp:useBean id="error" scope="request" type="java.lang.Boolean" />
<jsp:include page='partials/header.jsp'>
    <jsp:param name="title" value="Anmelden" />
    <jsp:param name="showRegistration" value="true" />
</jsp:include>

<main role="main" aria-labelledby="formheadline">
    <form class="form" method="post">
        <h2 id="formheadline" class="registration-headline">Anmelden</h2>
        <div class="form-row">
            <label class="form-label" for="email-input">
                Email
            </label>
            <input type="email" name="email" id="email-input" required class="form-input">
            <span id="email-error" class="error-text"></span>
        </div>
        <div class="form-row">
            <label class="form-label" for="password-input">
                Passwort
            </label>
            <input type="password" name="password" id="password-input" required class="form-input" minlength="4" maxlength="12">
            <span id="password-error" class="error-text"></span>
        </div>
        <div class="form-row form-row-center">
            <button class="button button-submit">
                Anmelden
            </button>
        </div>
    </form>
</main>
<jsp:include page='partials/footer.jsp'/>

UE3-Angabe/assignment/src/main/webapp/views/overview.jsp
<%@ page contentType="text/html;charset=UTF-8" language="java" %>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<jsp:useBean id="products" scope="request" type="java.util.Collection<at.ac.tuwien.big.we16.ue3.model.Product>" />
<jsp:useBean id="user" scope="request" type="at.ac.tuwien.big.we16.ue3.model.User" />
<fmt:setBundle basename="messages" />
<jsp:include page='partials/header.jsp'>
    <jsp:param name="title" value="Produkte" />
    <jsp:param name="showLogout" value="true" />
</jsp:include>
<jsp:include page='partials/sidebar.jsp' />
<c:set var="localeCode" value="${pageContext.response.locale}" />

<main role="main" aria-labelledby="productsheadline">
    <h2 class="main-headline" id="productsheadline">Produkte</h2>
    <ul class="products">
        <c:forEach items="${products}" var="product">
            <li class="product-outer" data-product-id="${product.id}">
                <a href="product/${product.id}" class="product <c:if test="${product.hasAuctionEnded()}">expired</c:if> <c:if test="${product.highestBid.isBy(user)}">highlight</c:if>" title="Mehr Informationen zu ${product.name}">
                    <img class="product-image" src="images/${product.image}" alt="${product.imageAlt}">
                    <dl class="product-properties properties">
                        <dt>Bezeichnung</dt>
                        <dd class="product-name">${product.name}</dd>
                        <dt>Preis</dt><dd class="product-price">
                            <c:choose>
                                <c:when test="${product.hasBids()}">
                                    <fmt:formatNumber value="${product.highestBid.convertedAmount}"  maxFractionDigits="2" minFractionDigits="2"/> €
                                </c:when>
                                <c:otherwise>
                                    <span class="no-bids">Noch keine Gebote</span>
                                </c:otherwise>
                            </c:choose>
                        </dd>
                        <dt>Verbleibende Zeit</dt><dd data-end-time="<fmt:formatDate value="${product.auctionEnd}" pattern="yyyy,MM,dd,HH,mm,ss,SSS"/>" data-end-text="abgelaufen" class="product-time js-time-left"></dd>
                        <dt>H\u00F6chstbietende/r</dt><dd class="product-highest">${product.highestBid.user.fullName}</dd>
                    </dl>
                </a>
            </li>
        </c:forEach>
    </ul>
</main>
<jsp:include page='partials/footer.jsp' />

UE3-Angabe/assignment/src/main/webapp/views/registration.jsp
<%@ page contentType="text/html;charset=UTF-8" language="java" %>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<fmt:setBundle basename="messages" />
<jsp:include page='partials/header.jsp'>
    <jsp:param name="title" value="Registrieren" />
    <jsp:param name="showLogin" value="false" />
</jsp:include>
<%at.ac.tuwien.big.we16.ue3.model.User userBean = (at.ac.tuwien.big.we16.ue3.model.User)request.getAttribute("user"); %>

<main role="main" aria-labelledby="formheadline">
    <form class="form" method="post">
        <h2 id="formheadline" class="registration-headline">Registrieren</h2>

        <fieldset>
            <legend>Persönliche Daten</legend>
            <div class="form-row">
                <label class="form-label" for="salutation-input">
                    Anrede *
                </label>
                <select name="salutation" id="salutation-input" class="form-input">
                    <option value="ms">Frau</option>
                    <option value="mr">Herr</option>
                </select>
 
            </div>
            <div class="form-row">
                <label class="form-label" for="firstname-input">
                    Vorname *
                </label>
                <input type="text" name="firstname" id="firstname-input" class="form-input" value="<%if(userBean!=null && request.getAttribute("firstname")==null) out.print(userBean.getFirstname()); %>">
                <% if (request.getAttribute("firstname")!=null) {out.print("Ungültiger Vorname");} %>
            </div>
            <div class="form-row">
                <label class="form-label" for="lastname-input">
                    Nachname *
                </label>
                <input type="text" name="lastname" id="lastname-input" class="form-input" value="<%if(userBean!=null && request.getAttribute("lastname")==null) out.print(userBean.getLastname()); %>">
           	<% if (request.getAttribute("lastname")!=null) {out.print("Ungültiger Nachname");} %>
            </div>
            <div class="form-row">
                <label class="form-label" for="dateofbirth-input">
                    Geburtsdatum *
                </label>
                <input type="text" name="dateofbirth" id="dateofbirth-input" class="form-input" value="<%if(userBean!=null && request.getAttribute("dateofbirth")==null) out.print(userBean.getDate()); %>">
            <% if (request.getAttribute("dateofbirth")!=null) {out.print("Ungültiges Geburtsdatum");} %>
            </div>
            <div class="form-row">
                <label class="form-label" for="email-input">
                    Email *
                </label>
                <input type="text" name="email" id="email-input" class="form-input" value="<%if(userBean!=null && request.getAttribute("email")==null) out.print(userBean.getEmail()); %>">
                <% if (request.getAttribute("email")!=null) {out.print("Ungültige Email");} %>
            </div>
            <div class="form-row">
                <label class="form-label" for="password-input">
                    Passwort *
                </label>
                <input type="password" name="password" id="password-input" class="form-input">
            <% if (request.getAttribute("password")!=null) {out.print("Ungültiges Passwort");} %>
            </div>
        </fieldset>

        <fieldset>
            <legend>Versandadresse</legend>
            <div class="form-row">
                <label class="form-label" for="streetAndNumber-input">
                    Straße/Hausnummer
                </label>
                <input type="text" name="streetAndNumber" id="streetAndNumber-input" class="form-input">
            </div>
            <div class="form-row">
                <label class="form-label" for="postcodeAndCity-input">
                    PLZ/Ort
                </label>
                <input type="text" name="postcodeAndCity" id="postcodeAndCity-input" class="form-input">
            </div>
            <div class="form-row">
                <label class="form-label" for="country-input">
                    Land
                </label>
                <select name="country" id="country-input" class="form-input">
                    <option value="at">Österreich</option>
                    <option value="de">Deutschland</option>
                    <option value="ch">Schweiz</option>
                </select>
            </div>
        </fieldset>

        <div class="form-row form-row-center">
            <p>
                <label for="terms">
                    <input type="checkbox" name="terms" id="terms" required onchange="isFormValid()">
                    Mit meiner Anmeldung akzeptiere ich die AGB. *
                </label>
            </p>
        </div>
        <div class="form-row form-row-center">
            <button class="button button-submit register-button">
                Registrieren
            </button>
        </div>
        <div class="form-row form-row-center">
            <p>
                Mit * gekennzeichnete Felder sind Pflichtfelder.
            </p>
        </div>
    </form>
</main>

<jsp:include page='partials/footer.jsp'/>